// $Id: xc_search.js,v 1.1.2.6 2010/01/15 23:33:42 mtwesley Exp $

var XCSearch = {};
if(Drupal.jsEnabled) {
  $(document).ready(function(){
    $('#select_all_action').click(function(){
      $('input[name=items]').each(function(){
        if(!this.checked) {
          this.checked = "checked";
        }
      });
    });
    $('#select_none_action').click(function(){
      $('input[name=items]').each(function(){
        if(this.checked) {
          this.checked = false;
        }
      });
    });
    $('#email_action').click(function(){
      var selectedItems = XCSearch.getSelectedItems();
      alert(selectedItems.join(', '));
    });
    $('#print_action').click(function(){
      var selectedItems = XCSearch.getSelectedItems();
      alert(selectedItems.join(', '));
    });
    $('#bookmark_action').click(function(){
      var selectedItems = XCSearch.getSelectedItems();
      for(i in selectedItems) {
        alert(selectedItems[i]);
        XCSearch.saveItem(selectedItems[i]);
      }
    });

    // iterate over images
    var image_info = Drupal.settings.xc_search.image_info;
    for(node_id in image_info) {
      XCSearch.getImage(node_id, image_info[node_id]);
    }
    
    // iterate over the NCIP information
    var ncip_info = Drupal.settings.xc_search.ncip_info;
    for(ncip_provider_id in ncip_info) {
      for(node_info_id in ncip_info[ncip_provider_id]) {
        for(node_id in ncip_info[ncip_provider_id][node_info_id]) {
          XCSearch.getAvailability(node_id, ncip_provider_id,
            ncip_info[ncip_provider_id][node_info_id][node_id]);
        }
      }
    }
  });
  
  /**
   * Get image URL, and insert it into HTML
   */
  XCSearch.getImage = function(node_id, options) {
    $.get(Drupal.settings.xc_search.image_url, options, function(data){
      syndetics = Drupal.parseJson(data);
      if(syndetics.image_url != "") {
        td = $('#coverart-' + node_id);
        td.html('<img src="' + syndetics.image_url + '">');
      }
    });
  };
  
  /**
   * Get availibility information and insert it into HTML
   * @param node_id The node id of the item in a search result list
   * @param ncip_id The NCIP server ID
   * @param bib_id  The bib ID of the item in a search result list
   */
  XCSearch.getAvailability = function(node_id, ncip_id, bib_id) {
    var options = {};
    options.ncip_id = ncip_id;
    options.bib_id  = bib_id;
    $.get(Drupal.settings.xc_search.ncip_url, options, function(data){
      ncip_info = Drupal.parseJson(data);
      if(ncip_info.availibility != "") {
        td = $('#xc-availibility-' + node_id);
        td.html(ncip_info.availibility);
      }
    });
  };
  
  XCSearch.saveItem = function(id) {
    var options = {'id': id};
    $.get(Drupal.settings.xc_search.save_item_url, options, function(data){
      alert(data);
      ncip_info = Drupal.parseJson(data);
      if(ncip_info.availibility != "") {
        td = $('#xc-availibility-' + node_id);
        td.html(ncip_info.availibility);
      }
    });
  };

  /**
   * Get the selected items in a search result list
   */
  XCSearch.getSelectedItems = function() {
    var selectedItems = [];
    $('input[name=items]').each(function(){
      if(this.checked) {
          selectedItems.push(this.value);
      }
    });
    return selectedItems;
  }

}